/**
 * \file manual.c
 */

/*!
 * Base object class.
 */
typedef struct _object
{
  int ref;    //!< \private Reference count.
} Object;


/*!
 * Increments object reference count by one.
 * \public \memberof Object
 */
Object * objRef(Object *obj);


/*!
 * Decrements object reference count by one.
 * \public \memberof Object
 */
Object * objUnref(Object *obj);

/*!
 * Do something to the object which requires a lot of parameters.
 * \public \memberof Object
 */
void objComplexThing(Object *obj, int a, void* b, void* c, void* d);

/*!
 * Do something simpler and typical to the object using the function 
 * that requires a lot of parameters.
 * \public \memberof Object
 */
#define objSimpleThing(obj) objComplexThing(obj, 0, NULL, NULL, NULL)

/*!
 * Main function.
 */
int main(void)
{
  Object o;
  objSimpleThing(&o);
}

